//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****      XFree - MARS 2002 - CopyRight  XC  Corporation		*****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                                  *****
//***************************************************************************
//***************************************************************************
#ifndef __XDSFREE
#define __XDSFREE

#define AddListBORLAND(vs,L) forstl(vstring,vs) L->AddItem(i->c_str(),NULL);

#include <math.h>
#include <dirent.h> // Pour TFiles
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <vector>
#include <algorithm> // Pour std::transform
#include <map>
#include <GL/GL.h> // Juste pour LoadBMPAlpha pour les fontes

#define MAX(a,b) ((a)<(b)?(b):(a))
#define MIN(a,b) ((a)>(b)?(b):(a))
#define CUT(x,a,b) if (x>b) x=b; if (x<a) x=a
#define ABS(i) ((i)>=0?(i):(-(i)))
#define PI    3.14159265358979
#define PISD  1.57079632679489

using namespace std;
typedef unsigned char   uchar;
typedef unsigned int    uint;
typedef vector<string>  vstring;         typedef map<string,string> mapss;
typedef vector<float>   vfloat;
typedef vector<int>     vint;
typedef vector<uint>    vuint;
#define cstring  const  string
#define cvstring const vstring
#define  forstl(vstr,nom)     for (vstr::iterator   i=nom.begin();   i!=nom.end(); i++)
#define forstl2(vstr,nom,var) for (vstr::iterator var=nom.begin(); var!=nom.end(); var++)

#define Zero(a)  memset(a,sizeof(a),0)
//#define Zero2(a) FillChar(&a,sizeof(a),0)
void glSortirProprement (string Msg);

//*******************************************************************************
//******   DD     ***************************************************************
//*******************************************************************************

class TDivers { public :
  bool Entre2 (float x,float a,float b)                   {return ( (x-a)*(x-b)<=0 );}
  void Trunci ( int  * PtVal  ,int   min,int   max)       {if (*PtVal<min) *PtVal=min; if (*PtVal>max) *PtVal=max;}
  void Truncf (float * PtVal  ,float min,float max)       {if (*PtVal<min) *PtVal=min; if (*PtVal>max) *PtVal=max;}

  float Puiss(float x,float n)                            {return((float)(exp (n*log(x))) );}
  float Unif (float a,float b)                            {return ( float( a + (b-a)*(rand()%10000)/10000.0  ) );}

  bool InRect (float x,float y,float x1,float y1,float x2,float y2) {return (    ( (x-x1)*(x-x2)<=0 ) && ( (y-y1)*(y-y2)<=0 )   );}

  bool IsPuiss2(int k)                                    {int o=1;for (int kk=1;kk<=log(k)/log(2);kk++) o*=2;return((k==o)||(k==o*2));}
  void CreePermutation (int * Permut,int NbElements)      {int k,j;int t=NbElements;for (k=0;k<t;k++){Again :  Permut[k]=rand()%t; for (j=0;j<k;j++) if (Permut[k]==Permut[j]) goto Again;}}
  void Classer(float * Inn,float * Out,int * IdxOut,int * Rang,int Nb);
  void Classer(int   * Inn,int   * Out,int * IdxOut,int * Rang,int Nb);
  long int HexToDec (string In);
#ifdef __BORLAND
  void AddList(vstring &vs, TListBox * L);
#endif

} extern DD;

void FillChar	 (void * pt,int qte,char value);


//*****************************************************************************
//****   XS  ****   XS2   *****************************************************
//*****************************************************************************

class TXString { public :
        //--- 1 ---
        int   StrToInt       (string source);
        float StrToFloat     (string source);
        void  StrToChar      (string StrIN, char * Dst);
        void  StrTovi        (string source,vint    &viout); // sparateur : ' '
        void  StrTovs        (string source,vstring &vsout); // sparateur : ' '
        void  StrTovf        (string source,vfloat  &vfout);
        string   IntToStr    (int i);
        string FloatToStr    (float f);
        string FloatToStr2Ch (float f);
        string T3fToStr2Ch   (void *f); // Paramtre = "&T3f" ou bien "float [3]"
        //--- 2 ---
        void Trim       (string &str); // enlve les ' ', 10, 13 en db et fin de str
        void CutComment (string &str); // enlve les "// commentaires"  la fin de str
        void Split      (string &str, string Separ, vstring &vsout); // "TX=1000" renvoie "TX","1000"
        void Spliti     (string &str, string Separ, vint    &viout); // "100 45" renvoie {100,45}
        void Splitf     (string &str, string Separ, vfloat  &vfout); // "100 45" renvoie {100,45}
        string ReplaceAll (const string &strIN, string Find, string ReplaceBy);
        //--- 3 ---
        string ToLower(const string &data);
        int CountChar (string &str, char ch) {int res=0; for (uint kk=0;kk<str.length();kk++) if (str[kk]==ch)res++;return(res);}
        bool MemeDeb  (string str1,string str2);

} extern XS;

#include <windows.h>
CHAR wide_to_narrow(WCHAR w);
class TXString2 { public :
        string  vstring2string  (vstring &vs,string sep=" ");
        string  vint2string     (vint    &vi,string sep=" ");
        string  vfloat2string   (vfloat  &vf,string sep=" ");
        void    StringToChar    (string StrSRC, char * StrDST); // a malloc PAS le char *
        string  ExtractNameWithoutPath  (const string &NomCplet);
        string  ExtractPath             (const string &NomCplet, bool WithSlash);
        string  ExtractExt              (const string &NomCplet); // renvoie "txt" ou "bmp" par exemple
        string  ExtractNameNoExt        (const string &NomCplet);
        string  ExtractNameNoExtNoPath  (const string &NomCplet);
        bool    HasChar(char ch, string Str);


        void char2WCHAR300 (const char  * in, WCHAR * out){mbstowcs( out , in , 300);}
        void WCHAR2char300 (const WCHAR * in, char  * out){std::transform(in , in + 300, out, wide_to_narrow);}
} extern XS2;

//*************************************************************************
//***** FILE **************************************************************
//*************************************************************************

class TFile { public : FILE * fptr;
                        int   size;
                        char * Data;
                        char * Str;
                        bool eof() {return ((Str==NULL)||(Str-Data>=size));}
                        bool Load (string NomFich);
                        void GoNxtLineFull(int Nb) { for (int k=0; k<Nb; k++) {while ((!eof())&&(*Str)&&(*Str!=10)&&(*Str!=13)) Str++; while (((*Str==10)||(*Str==13))&&(*Str)) Str++;} }
                        bool GoNxtChar(char Ch)    { while  ((!eof())&&(*Str)&&(*Str!=Ch)) Str++; bool res=*Str;Str++; return(res);}
                        char MoveToNxtChar()       { while  ((!eof())&&(*Str)&& ((*Str==' ')||(*Str==9)||(*Str==10)||(*Str==13))) Str++; return(*Str); }
                        void MoveToNxtLine()       { while  ((!eof())&&(*Str)&&(*Str!=10)&&(*Str!=13)) Str++; while(*Str==10||*Str==13) Str++;return; }
                        void CopyLine (char * Dst) { while ((!eof())&&(*Str!=10)&&(*Str!=13)) {*Dst++=*Str++;} *Dst=0;} // copie Str -> Dst jusqu' fin ligne
                        string CopyLineGoNxt ();
                        string CopyWordGoNxt ();
                        int      ReadIntAct  ();  // a va au prochain caractre != ( esp, 10, 13)
                        float    ReadFloatAct();   // a va au prochain caractre != ( esp, 10, 13)
                        float    ReadFloatMove();  // ReadFloatAct PUIS MoveToNxtChar
                        string   ReadStrAct  ();       // a va     au prochain caractre != ( esp, 10, 13)
                        string   ReadStrActNoMove();   // a va PAS au prochain caractre != ( esp, 10, 13)
                        int      ReadNxtIntEgal();      // Renvoie le prochain entier form aprs le prochain '=' et met Str aprs le '='
                        string   ReadNxtStrEgal();      // Renvoie le prochain string form aprs le prochain '=' et met Str  la NxtLigne
                        string   ReadNxtStrEgal2();     // Renvoie le prochain string form aprs le prochain '=' et met Str aprs le '='
                        float    ReadNxtFloatEgal();    // Renvoie le prochain float  form aprs le prochain '=' et met Str aprs le '='
                        string   ReadStrFinLgn();      // Renvoie le String depuis Str jusqu'au caractre ENTER ou 0 ou eof, et ne bouge pas Str
                        string   ReadStrFinLgnMove() { string R = ReadStrFinLgn();    GoNxtLineFull(1);    return(R); }
                        void FreeData()         {free(Data);Data=0;}
                        TFile() {Data=0;}
                        ~TFile() {if (Data) FreeData();};
};

//*****************************************************************************
//****  Files ***  Filec  *****************************************************
//*****************************************************************************

class TFiles {
public :
  bool   Exists        (string NomFich);
  long   Size          (string NomFich);
  void   Delete        (string NomFich);
  void   Rename        (string OldName, string NewName);
  bool   Copy          (string StrSrc , string StrDst);
  void   Dir           (string StrWhat, vstring & vs, bool AvecRepDotDot=false, bool AvecStrRep=false);     // ex : Files.Dir ("Data\\*.jpg" , mon_vs);
  void   Execute       (string   StrDir ,  string StrCommand);                 // "Repertoire" , sans les '\\'
  void   Execute       (string StrCommand) {Execute ("",StrCommand);}
  void   Executebat    (cstring &StrDir, cvstring &vs,        bool AvecEnter); // "Repertoire" , sans les '\\'
  void   Executebat    (cstring &StrDir, cstring &StrCommand, bool AvecEnter); // "Repertoire" , sans les '\\'
  void   Transform2DOS (string NomFich) {Transform2DOS(NomFich,NomFich);}
  void   Transform2DOS (string NomFichSrc, string NomFichDst);
  bool   IsDirectory   (string NomFich);
  string GetCurrentDir ();
  void   CreateDir     (string StrDir); // ex : "CreateDir ("OBJ/Palmier"); sans le SLASH  la fin
  void   RemoveDir     (string StrDir); // ex : "RemoveDir ("OBJ/Palmier"); sans le SLASH  la fin
  void   DeleteDir     (string StrDir, string StarPointStar="*.*");      // "Repertoire" , sans les '\\'
  void   LoadDir       (string Path, vstring &OutFiles, string ext, bool AvecDir);  // ext = "" pour avoir tout
  void   LoadRep       (string Path, vstring &OutRep, bool AvecPoitEtPointPoint);
} extern Files;

class TFilec { public :
  int     Loadi  (string NomFich, string Champ); // chercher "Champ = 1400" et renvoie 1400
  float   Loadf  (string NomFich, string Champ);
  string  Loads  (string NomFich, string Champ);
  void    Loadvi (string NomFich, string Champ,vint &vi);

  void    Savei  (string NomFich, string Champ, int    val) {Saves(NomFich,Champ,XS.IntToStr  (val));}
  void    Savef  (string NomFich, string Champ, float  val) {Saves(NomFich,Champ,XS.FloatToStr(val));}
  void    Saves  (string NomFich, string Champ, string val);
} extern Filec;

//*****************************************************************************
//**** TFile **** TFilew **** TFiler ******************************************
//*****************************************************************************

class TFileINI { public :
                vstring strs;                                       // toutes les lignes du fichier (lu par Load)
                mapss   maps;                                       // "TX","1000"                  (cre par BuildMap)

                void    Load(string NomFich,bool Buildmap=true);    // remplit "strs" et c'est tout
                void    BuildMap();                                 // remplit "maps" (c.f. .cpp) ( "TX = 1400 1500" fait maps["TX"]="1400 1500" )
                void    Nettoie_strs();                             // dgage lignes vides et commentaires
                TFileINI  (){};
                TFileINI  (string NomFich, bool Buildmap=true) {Load(NomFich,Buildmap);}
};

#define FdataW(a)  F.Wri_data(a,sizeof(a))
#define FdataWe(a) F.Wri_data(&a,sizeof(a))
#define FdataR(a)  F.Read_data(a,sizeof(a))
#define FdataRe(a) F.Read_data(&a,sizeof(a))

class TFilew { public : FILE * fptr;
   bool Open(string NomFich);
   bool Wri_bool   (bool   b)               {if (fptr==NULL) return(false);fwrite (&b, sizeof(b), 1, fptr);return(true);}
   bool Wri_int    (int    i)               {if (fptr==NULL) return(false);fwrite (&i, sizeof(i), 1, fptr);return(true);}
   bool Wri_float  (float  f)               {if (fptr==NULL) return(false);fwrite (&f, sizeof(f), 1, fptr);return(true);}
   bool Wri_double (double d)               {if (fptr==NULL) return(false);fwrite (&d, sizeof(d), 1, fptr);return(true);}
   bool Wri_data(void * d, int NbOct)       {if (fptr==NULL) return(false);fwrite ( d, NbOct    , 1, fptr);return(true);}
   bool Wri_string    (const string &s, bool Enter); // Pour fichier textes : crit le texte, c'est tout
   bool Wri_strfloat  (float * f, int Nb, bool DeuxCh, bool Enter);
   bool Wri_string2   (string s);    // crit la size du string, puis le "string sans 0  la fin"
   bool Wri_string100 (string s);    // a crit 100 octets, ni plus ni moins  avec le 0  la fin
   bool Wri_vs     (vstring &vs);
   bool Wri_intStr (int i,bool Enter);
//   bool Wri_ASAlign(string &AS, bool Enter, int NbCarac);   // Commence avec des espaces pour crire au total NbCarac chars
   bool Wri_Enter  (int Nb);
   void Close();
   TFilew(){fptr=NULL;}
   TFilew(string NF) { Open(NF);};
   ~TFilew()         { Close(); };
};

class TFilerb {
public :
    FILE * fptr;
    bool Open(string NomFich);// juste l'ouverture
    bool Read_bool   (bool   &b)            {if (fptr==NULL) return(false);fread (&b, sizeof(b), 1, fptr);return(true);}
    bool Read_int    (int    &i)            {if (fptr==NULL) return(false);fread (&i, sizeof(i), 1, fptr);return(true);}
    bool Read_float  (float  &f)            {if (fptr==NULL) return(false);fread (&f, sizeof(f), 1, fptr);return(true);}
    bool Read_double (double &d)            {if (fptr==NULL) return(false);fread (&d, sizeof(d), 1, fptr);return(true);}
    bool Read_data   (void * d, int NbOct)  {if (fptr==NULL) return(false);fread ( d, NbOct    , 1, fptr);return(true);}
    bool Read_string2   (string &s);  // lit la size du string, puis le "string sans le 0  la fin"
    bool Read_string100 (string &s);  // a prend 100 octets, ni plus ni moins  avec le 0  la fin
    void Close();

    bool Load(string NomFich);// ouverture + liretout dans p + Close. (normal quoi!)
    void Free() {if (p)free(p);p=NULL;}
    char * p;
    TFilerb(string NomFich) {Load(NomFich);}
    TFilerb()               {fptr=NULL; p=0;}
    ~TFilerb() {Free();}
};


//*****************************************************************************
//***** TXRect ****************************************************************
//*****************************************************************************

class TXRect {public :
        float x1,x2,y1,y2;
        void Set(float x,float y,float xx,float yy) {x1=x;y1=y;x2=xx;y2=yy;}
        TXRect  (float x=0,float y=0,float xx=0,float yy=0) {Set(x,y,xx,yy);}
};


#endif
