//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****      XMaths - JUIN 2011 - CopyRight  XC  Corporation		*****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                                  *****
//***************************************************************************
//***************************************************************************

#include "XMaths.h"



//*******************************************************************************
//****** XTri *******************************************************************
//*******************************************************************************
TXTri XTri;
TGeo   Geo;
//----------------------------------------------------------
void TXTri::Tri_f_idxrec  (int * Iin, int Nb_I, int * Iout)
{
        if (Nb_I==0) return;
        if (Nb_I==1) {*Iout=*Iin;return;}
        if (Nb_I==2) { if (Nb[Iin[0]]<Nb[Iin[1]])    {Iout[0]=Iin[0]; Iout[1]=Iin[1]; return;}
                                                else {Iout[0]=Iin[1]; Iout[1]=Iin[0]; return;}  }
        int Nb1 = Nb_I/2;
        int Nb2 = Nb_I - Nb1;
        int * I1=(int*)malloc( Nb1*sizeof(int) );
        int * I2=(int*)malloc( Nb2*sizeof(int) );
        Tri_f_idxrec( Iin     , Nb1, I1);
        Tri_f_idxrec(&Iin[Nb1], Nb2, I2);
        Fusionne_f_Idx(I1,Nb1,I2,Nb2,Iout);
        free(I1); free(I2);
}
//----------------------------------------------------------
void TXTri::Tri_f (float * Lin, int Nb_f, float * Lout)
{
        if (Nb_f==0) return;
        if (Nb_f==1) {*Lout=*Lin;return;}
        if (Nb_f==2) { if (Lin[0]<Lin[1])    {Lout[0]=Lin[0]; Lout[1]=Lin[1]; return;}
                                        else {Lout[0]=Lin[1]; Lout[1]=Lin[0]; return;}  }
        int Nb1 = Nb_f/2;
        int Nb2 = Nb_f - Nb1;
        float * L1=(float*)malloc( Nb1*sizeof(float) );
        float * L2=(float*)malloc( Nb2*sizeof(float) );
        Tri_f( Lin     , Nb1, L1);
        Tri_f(&Lin[Nb1], Nb2, L2);
        Fusionne_f(L1,Nb1,L2,Nb2,Lout);
        free(L1); free(L2);
}
//----------------------------------------------------------
void TXTri::Fusionne_f( float * L1, int Nb1, float * L2, int Nb2, float * L3)
{       int k1=0; int k2=0;
        while (k1!=Nb1 || k2!=Nb2)
        {            if (k1==Nb1) {*L3++ = *L2++; k2++;}
                else if (k2==Nb2) {*L3++ = *L1++; k1++;}
                else if (*L1<*L2) {*L3++ = *L1++; k1++;}
                else              {*L3++ = *L2++; k2++;}
        }
}
//----------------------------------------------------------
void TXTri::Fusionne_f_Idx( int * I1, int Nb1, int * I2, int Nb2, int * I3)
{       int k1=0; int k2=0;
        while (k1!=Nb1 || k2!=Nb2)
        {            if (k1==Nb1) {*I3++ = *I2++; k2++;}
                else if (k2==Nb2) {*I3++ = *I1++; k1++;}
                else if (Nb[*I1]<Nb[*I2]) {*I3++ = *I1++; k1++;}
                else                      {*I3++ = *I2++; k2++;}
        }
}
//----------------------------------------------------------
void TXTri::Classer(float * Inn,float * Out,int * IdxOut,int * Rang,int Nb)
{
	float * In=(float*)malloc(sizeof(float)*Nb);memcpy(In,Inn,sizeof(float)*Nb);
	//--- tri naf !!! ---
	int k,j,idx;
	float max,min;//*** Je mettrai max+1 pour dire queue je l'ai dj trait
	max=In[0];
	for (k=0;k<Nb;k++) if (In[k]>max)  max =In[k];
	for (k=0;k<Nb;k++)
	{
		min=max+1;
		idx=0;
		for (j=0;j<Nb;j++) if (In[j]<min) {min=In[j];idx=j;}
		//--- hop! on a le + petit actuel
		if (Out)    Out[k]   =min;      // ------> SI NULL on fait rien
		if (IdxOut) IdxOut[k]=idx;      // ------> SI NULL on fait rien
                if (Rang)   Rang[idx] =k;       // ------> SI NULL on fait rien
		In[idx]=max+1;
	}
	free(In);
}
//***************************************************************************
void TXTri::Classer(int * Inn,int * Out,int * IdxOut,int * Rang,int Nb)
{
  float * innFLOAT=(float*)malloc(sizeof(float)*Nb);for (int k=0; k<Nb; k++) innFLOAT[k]=Inn[k];
  float * outFLOAT=(float*)malloc(sizeof(float)*Nb);
  Classer(innFLOAT, outFLOAT, IdxOut, Rang, Nb);         for (int k=0; k<Nb; k++) outFLOAT[k]=Out[k];
  free(outFLOAT);free(innFLOAT);
}


//*****************************************************************************
//********* T2f T3f T2i *******************************************************
//*****************************************************************************

   T3f::T3f(float xx,float yy,float zz) {x=xx; y=yy; z=zz;}
T3f T3f::operator + (const T3f& Pt)      const{T3f Rep;	Rep.x=x+Pt.x;	Rep.y=y+Pt.y;   Rep.z=z+Pt.z;	return Rep;}
T3f T3f::operator - (const T3f& Pt)      const{T3f Rep;	Rep.x=x-Pt.x;	Rep.y=y-Pt.y;   Rep.z=z-Pt.z;	return Rep;}
T3f T3f::operator * (const float Lambda) const{T3f Rep;	Rep.x=x*Lambda;	Rep.y=y*Lambda;	Rep.z=z*Lambda; return Rep;}
T3f T3f::operator ^ (const T3f& Pt)      const{T3f Rep;	Rep.x=y*Pt.z - z*Pt.y;
                                                        Rep.y=z*Pt.x - x*Pt.z;
                                                        Rep.z=x*Pt.y - y*Pt.x;
                                                        return Rep;}
float T3f::Scal (T3f p){return(this->x*p.x + this->y*p.y + this->z*p.z);}

inline float T3f::Norme()     {return ( SQRT(SQR(x)+SQR(y)+SQR(z))  );}
       void  T3f::Normalize() {float r=Norme();if (r==0) return;*this= *this * (1/r);}
string T3f::Str() {return("x="+XS.FloatToStr2Ch(x)+" y="+XS.FloatToStr2Ch(y)+" z="+XS.FloatToStr2Ch(z));} // !!! Cette ligne peut TOUT FAIRE PLANTER !! Borland SHIT !!!

//------------------------------------------------------------------------------

    T2f::T2f(float x,float y) {this->x=x;this->y=y;}
T2f T2f::operator + (const T2f& Pt)      const{T2f Rep;	Rep.x=x+Pt.x;	Rep.y=y+Pt.y;  return Rep;}
T2f T2f::operator - (const T2f& Pt)      const{T2f Rep;	Rep.x=x-Pt.x;	Rep.y=y-Pt.y;  return Rep;}
T2f T2f::operator * (const float Lambda) const{T2f Rep;	Rep.x=x*Lambda;	Rep.y=y*Lambda;	return Rep;}
float T2f::Norme()     {return ( sqrt(SQR(x)+SQR(y))  );}
void  T2f::Normalize() {float r=Norme();if (r==0) return;*this= *this * (1/r);}
float T2f::Scal (T2f p){return(this->x*p.x + this->y*p.y );}

//------------------------------------------------------------------------------

inline T2i  T2i::operator +  (const T2i& Pt)      const{T2i Rep;	Rep.x=x+Pt.x;	Rep.y=y+Pt.y;   return Rep;}
inline T2i  T2i::operator -  (const T2i& Pt)      const{T2i Rep;	Rep.x=x-Pt.x;	Rep.y=y-Pt.y;   return Rep;}
inline T2i  T2i::operator *  (const int Lambda)   const{T2i Rep;	Rep.x=x*Lambda;	Rep.y=y*Lambda; return Rep;}
inline bool T2i::operator == (const T2i& Pt)      const{ return ((x==Pt.x)&&(y==Pt.y)) ;}
inline float T2i::Norme()       {return ( SQRT(SQR(x)+SQR(y)) ) ;}
inline int   T2i::SqrNorme()    {return (     (SQR(x)+SQR(y)) ) ;}
inline int   T2i::Scal  (T2i p)  {return(this->x*p.x + this->y*p.y);}
inline float T2i::ScalN (T2i p)  {float N1=Norme();float N2=p.Norme();if (N1*N2==0) return(0); else return((x*p.x + y*p.y)/(N1*N2));}
inline int   T2i::Dist2 (T2i p)  {return(SQR(this->x-p.x) + SQR(this->y-p.y));}
inline void  T2i::Rot90 ()       {int TMP=this->x; this->x=-this->y; this->y=TMP;}

//***************************************************************************************************************************************************************************
//***************************************************************************************************************************************************************************
//***************************************************************************************************************************************************************************
bool TGeo::MemeCote (T2f A, T2f B, T2f C, T2f D)  // renvoie (A et B du mme ct de (CD) )
{
        return ( true );
}
bool TGeo::TriDirect(T2f A,T2f B,T2f C)
{
        T2f AB = B-A;
        T2f AC = C-A;
        return (AB.x*AC.y - AB.y*AC.x >=0);
}
//------------------------------------------------
bool TGeo::Secant   (T2f A, T2f B, T2f C, T2f D)
{
        bool b1 = TriDirect (A,D,B);
        bool b2 = TriDirect (D,B,C);
        bool b3 = TriDirect (B,C,A);
        bool b4 = TriDirect (C,A,D);
        return ( ( b1 &&  b2 &&  b3 &&  b4)
            ||   (!b1 && !b2 && !b3 && !b4)  );
}
