#ifndef FREE_NEHE_H
#define FREE_NEHE_H

#include "..\XCSGL.h"
#include "ft2build.h"
#include <freetype/freetype.h>
#include <freetype/ftglyph.h>
#include <freetype/ftoutln.h>
#include <freetype/fttrigon.h>
#include <stdexcept>

class TTFont { public :

        void LoadFont_FT(string NomFich, int height);
        void FreeFont_FT() {	if (!FontChargee) return;
                                FT_Done_Face(face);
                        	    FT_Done_FreeType(library);  FontChargee=false;    }
        bool FontChargee;
        int Height;
        float txchar[256]; // Pour calculer la taille du texte, c'est tout.


        //----------- Tout pour du local
        GLuint * textures;
        GLuint list_base;
        bool   TexChargees;
        void   CreeTex_FT ();     // met TexChargees  true
        float  TxTexte                          (string str, float size1=1 );
        void   Print       (float x , float y  , string str, float size1=1 );
        void   PrintCenter (float xC, float yC , string str, float size1=1 );


        void FreeTex_FT () {
                if (!TexChargees) return;
                glDeleteLists (list_base,128);glDeleteTextures(128,textures);
                delete []textures; textures=NULL;TexChargees=false;}
        //-----------

        void Export_AllLetters(string DebutFich);
        void Export_glFonte   (string NomFichNoExt , GLuint TXBMP);

        float CoefMultEnter;
        string Alphabet;
        TTFont() { textures = NULL; FontChargee=TexChargees=false;CoefMultEnter=1.3;
                   Alphabet = "!?#$%&'()*+,-./:;<=>[]@ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789|{}_\"\\";
                };

        private :
	    FT_Library      library;       //  librer aprs usage
        FT_Face         face;          //  librer aprs usage

};


#endif
